# Thư viện API PHP AppTeng

Bạn có thể tham khảo tài liệu dành cho nhà phát triển để biết các phương thức và tham số khả dụng

[Tài liệu API Documentation](https://appteng.net/hd/danh-cho-nha-phat-trien/tai-lieu-api/)

## Sử dụng cơ bản

#### Khởi tạo API bằng mã thông báo Auth hoặc Bearer cơ bản

```php

// Init with Basic Auth username/password
\appteng\Api::init($domain, $username, $password);

// OR

// Init with Bearer token
\appteng\Api::initWithBearer($domain, $bearerToken);
```

#### Tạo người dùng mới

```
$response = \appteng\User::create($email, $password, $firstname, $lastname, $role_id);
if($response->isSuccess()) {
    $user_id = $response->getResponse("user_id");
    $token  = $response->getResponse("token");
} else {
    echo $response->getErrorMessage();
}
```

#### Tạo một ứng dụng

```
$response = \appteng\Application::create($name, $user_id);
if($response->isSuccess()) {
    $app_id = $response->getResponse("app_id");
    $app_url  = $response->getResponse("app_url");
} else {
    echo $response->getErrorMessage();
}
```

Các hướng dẫn thao tác khác được mô tả lại ở đây [API Documentation](https://appteng.net/hd/danh-cho-nha-phat-trien/tai-lieu-api/)


#### Chạy thử nghiệm (ví dụ về sự phát triển của bạn)

Xác thực cơ bản

```
./run-test.sh apptengurl basic username password
```

Mã thông báo

```
./run-test.sh apptengurl bearer token
```